/*
 * ps2_uart.c
 *
 * Created: 12/27/2011 9:45:03 AM
 *  Author: intembp
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>

#include "usbdrv/oddebug.h"
#include "ps2_uart.h"
#include "rb.h"
#include "misc.h"

extern rb_t scancodes;

ISR(USART_RX_vect)//, ISR_NOBLOCK)
{
	uint8_t sc = UDR0;
	sei();
	rb_add(&scancodes, sc);
}

void inline ps2_uart_read()
{
	if (RB(UCSR0A, RXC0))
		rb_add(&scancodes, UDR0);
}

void ps2_uart_init()
{	
	UCSR0C |= (1 << UMSEL00) |
		  	  (1 << UPM00)   |
			  (1 << UPM01)   |
			  (1 << UCSZ00)  |
			  (1 << UCSZ01);
			  
	UCSR0B |= (1 << RXCIE0)  |
			  (1 << RXEN0);
}