#include <avr/io.h>
#include <avr/interrupt.h>

#include "usbdrv/oddebug.h"
#include "rb.h"

void rb_init(rb_t* rb, TYPE* data, TYPE size)
{
	rb->data = data;
	rb->size = size - 1;
	rb->head = rb->tail = 0;
}

inline bool rb_add(rb_t* rb, TYPE e)
{
	cli();
	
	if (((rb->tail + 1) & rb->size) == rb->head) {
		sei();
		return false; // full
	}		
	
	rb->data[rb->tail] = e;
	
	rb->tail = ((rb->tail + 1) & (rb->size));

	sei();

	return true;
}

inline bool rb_get(rb_t* rb, TYPE* e)
{
	cli();
	
	if (rb->head == rb->tail) {
		sei();
		return false;
	}	
	
	*e = rb->data[rb->head];
	
	rb->head = (rb->head + 1) & (rb->size);
	
	sei();
	
	return true;
}

//inline bool rb_add(rb_t* rb, TYPE e)
//{
	//if ((rb->tail + 1) % rb->size != rb->head) {
		//rb->data[rb->tail] = e;
		//rb->tail++;
//
		//if (rb->tail == rb->size)
			//rb->tail = 0;
//
		//return true;
	//}
	//return false;
//}
//
//inline bool rb_get(rb_t* rb, TYPE* e)
//{
	//if (rb->head == rb->tail)
		//return false;
//
	//cli();
//
	//*e = rb->data[rb->head];
//
	//rb->head++;
//
	//if (rb->head == rb->size)
		//rb->head = 0;
//
	//sei();
//
	//return true;
//}

bool rb_peek(rb_t* rb, TYPE* e)
{
	if (rb->head == rb->tail)
		return false;
	
	*e = rb->data[rb->head];
	
	return true;
}

inline bool rb_empty(rb_t* rb)
{
	return rb->head == rb->tail;
}
