/*
 * report.c
 *
 *  Created on: Dec 24, 2011
 *      Author: intembp
 */

#include <avr/io.h>

#include "report.h"

report_t report;

static bool changed = false;

void report_init()
{
	uint8_t i;

	report.modifiers = 0;

	for (i = 0; i < NUM_KEYS; i++)
		report.keys[i] = 0;
}

void report_clear()
{
	report_init();
	
	changed = true;
}

bool report_add(uint8_t uid)
{
	uint8_t i, free_slot = NUM_KEYS;

	for (i = 0; i < NUM_KEYS; i++) {
		if (report.keys[i] == 0)
			free_slot = i;
		if (report.keys[i] == uid) {
			return false;
		} else {
			if (uid >= 0xE0 && uid <= 0xE7) { // modifiers
				if (report.modifiers & (1 << (uid - 0xE0)))
					return false;
				report.modifiers |= (1 << (uid - 0xE0));
				changed = true;
				return true;
			} else if (free_slot < NUM_KEYS) {
				report.keys[free_slot] = uid;
				changed = true;
				return true;
			}
		}
	}
	return false;
}

bool report_remove(uint8_t uid)
{
	uint8_t i;

	for (i = 0; i < NUM_KEYS; i++) {
		if (uid >= 0xE0 && uid <= 0xE7) {
			report.modifiers &= ~(1 << (uid - 0xE0));
			changed = true;
			return true;
		} else if (report.keys[i] == uid) {
			report.keys[i] = 0;
			changed = true;
		}
	}
	return false;
}

bool report_changed()
{
	if (changed) {
		changed = false;
		return true;
	} else {
		return false;
	}
}
