/*
 * soft_uart.c
 *
 * Created: 2012-01-01 16:05:40
 *  Author: inte
 */ 

#include <avr/io.h>
#include <util/delay.h>

#define BIT_TIME 104 // (1e6/9600)

#define STX_DDR  DDRC
#define STX_PORT PORTC
#define STX_BIT  PINC0

// http://www.avrfreaks.net/index.php?name=PNphpBB2&file=printview&t=95903&start=0

static void inline nops(uint8_t n)
{
	while (n--)
		asm volatile ("nop");
}

void sputchar(uint8_t c)
{
	uint8_t i;
	
	STX_DDR |= (1 << STX_BIT);
	
	c = ~c;
	STX_PORT &= ~(1 << STX_BIT);	// start bit
	
	for (i = 10; i; i--) {			// 10 bits
		_delay_us(BIT_TIME);		// bit duration
		
		if (c & 1)
			STX_PORT &= ~(1 << STX_BIT);	// data bit 0
		else
			STX_PORT |= 1 << STX_BIT;		// data bit 1 or stop bit
		
		c >>= 1;
	}
}