/*
 * ttable.h
 *
 *  Created on: Dec 23, 2011
 *      Author: intembp
 */

#ifndef TTABLE_H_
#define TTABLE_H_

#include <avr/pgmspace.h>

#define S_COUNT 0xFC
#define E_COUNT 0x7E

PROGMEM uint8_t sc_hid_standard[] =
{
	0x00, //0x01, // 00 (Overrun Error, disabled)
	0x42, // 01 (F9)
	0x00, // 02 (unassigned)
	0x3E, // 03 (F5)
	0x3C, // 04 (F3)
	0x3A, // 05 (F1)
	0x3B, // 06 (F2)
	0x45, // 07 (F12)
	0x68, // 08 (F13)
	0x43, // 09 (F10)
	0x41, // 0A (F8)
	0x3F, // 0B (F6)
	0x3D, // 0C (F4)
	0x2B, // 0D (Tab)
	0x35, // 0E (` ~)
	0x67, // 0F (Keypad =)
	0x69, // 10 (F14)
	0xE2, // 11 (Left Alt)
	0xE1, // 12 (Left Shift)
	0x88, // 13 (Keyboard Intl'2 ???? ???? ???? (Katakana/Hiragana))
	0xE0, // 14 (Left Control)
	0x14, // 15 (q Q)
	0x1E, // 16 (1 !)
	0x00, // 17 (unassigned)
	0x6A, // 18 (F15)
	0x00, // 19 (unassigned)
	0x1D, // 1A (z Z)
	0x16, // 1B (s S)
	0x04, // 1C (a A)
	0x1A, // 1D (w W)
	0x1F, // 1E (2 @)
	0x00, // 1F (unassigned)
	0x6B, // 20 (F16)
	0x06, // 21 (c C)
	0x1B, // 22 (x X)
	0x07, // 23 (d D)
	0x08, // 24 (e E)
	0x21, // 25 (4 $)
	0x20, // 26 (3 #)
	0x8C, // 27 (Keyboard Int'l 6 (PC9800 Keypad , ))
	0x6C, // 28 (F17)
	0x2C, // 29 (Space)
	0x19, // 2A (v V)
	0x09, // 2B (f F)
	0x17, // 2C (t T)
	0x15, // 2D (r R)
	0x22, // 2E (5 %)
	0x00, // 2F (unassigned)
	0x6D, // 30 (F18)
	0x11, // 31 (n N)
	0x05, // 32 (b B)
	0x0B, // 33 (h H)
	0x0A, // 34 (g G)
	0x1C, // 35 (y Y)
	0x23, // 36 (6 ^)
	0x00, // 37 (unassigned)
	0x6E, // 38 (F19)
	0x00, // 39 (unassigned)
	0x10, // 3A (m M)
	0x0D, // 3B (j J)
	0x18, // 3C (u U)
	0x24, // 3D (7 &)
	0x25, // 3E (8 *)
	0x00, // 3F (unassigned)
	0x6F, // 40 (F20)
	0x36, // 41 (, <)
	0x0E, // 42 (k K)
	0x0C, // 43 (i I)
	0x12, // 44 (o O)
	0x27, // 45 (0 ))
	0x26, // 46 (9 ()
	0x00, // 47 (unassigned)
	0x70, // 48 (F21)
	0x37, // 49 (. >)
	0x38, // 4A (/ ?)
	0x0F, // 4B (l L)
	0x33, // 4C (: ;)
	0x13, // 4D (p P)
	0x2D, // 4E (- _)
	0x00, // 4F (unassigned)
	0x71, // 50 (F22)
	0x87, // 51 (Keyboard Int'l 1 ? (Ro))
	0x34, // 52 (' )
	0x00, // 53 (unassigned)
	0x2F, // 54 ([ {)
	0x2E, // 55 (= +)
	0x00, // 56 (unassigned)
	0x72, // 57 (F23)
	0x39, // 58 (Caps Lock)
	0xE5, // 59 (Right Shift)
	0x28, // 5A (Return)
	0x30, // 5B (] })
	0x00, // 5C (unassigned)
#ifndef USE_INTL
	0x31, // 5D (\ |  )
#else
	0x32, // 5D (Europe 1 (Note 2))
#endif
	0x00, // 5E (unassigned)
#ifndef USE_INTL
	0x73, // 5F (F24)
#else
	0x94, // 5F (Keyboard Lang 5 ??/?? (Zenkaku/Hankaku))
#endif
	0x00, // 60 (unassigned)
	0x64, // 61 (Europe 2 (Note 2))
	0x93, // 62 (Keyboard Lang 4 ???? (Hiragana))
	0x92, // 63 (Keyboard Lang 3 ???? (Katakana))
	0x8A, // 64 (Keyboard Int'l 4 ??? ?? (???) ??? (Henkan))
	0x00, // 65 (unassigned)
	0x2A, // 66 (Backspace)
	0x8B, // 67 (Keyboard Int'l 5 ??? (Muhenkan))
	0x00, // 68 (unassigned)
	0x59, // 69 (Keypad 1 End)
	0x89, // 6A (Keyboard Int'l 2  (Yen))
	0x5C, // 6B (Keypad 4 Left)
	0x5F, // 6C (Keypad 7 Home)
	0x85, // 6D (Keypad , (Brazilian Keypad .))
	0x00, // 6E (unassigned)
	0x00, // 6F (unassigned)
	0x62, // 70 (Keypad 0 Insert)
	0x63, // 71 (Keypad . Delete)
	0x5A, // 72 (Keypad 2 Down)
	0x5D, // 73 (Keypad 5)
	0x5E, // 74 (Keypad 6 Right)
	0x60, // 75 (Keypad 8 Up)
	0x29, // 76 (Escape)
	0x53, // 77 (Num Lock)
	0x44, // 78 (F11)
	0x57, // 79 (Keypad +)
	0x5B, // 7A (Keypad 3 PageDn)
	0x56, // 7B (Keypad -)
	0x55, // 7C (Keypad *)
	0x61, // 7D (Keypad 9 PageUp)
	0x47, // 7E (Scroll Lock)
	0x00, // 7F (unassigned)
	0x00, // 80 (unassigned)
	0x00, // 81 (unassigned)
	0x00, // 82 (unassigned)
	0x40, // 83 (F7)
	0x00, // 84 (unassigned)
	0x00, // 85 (unassigned)
	0x00, // 86 (unassigned)
	0x00, // 87 (unassigned)
	0x00, // 88 (unassigned)
	0x00, // 89 (unassigned)
	0x00, // 8A (unassigned)
	0x00, // 8B (unassigned)
	0x00, // 8C (unassigned)
	0x00, // 8D (unassigned)
	0x00, // 8E (unassigned)
	0x00, // 8F (unassigned)
	0x00, // 90 (unassigned)
	0x00, // 91 (unassigned)
	0x00, // 92 (unassigned)
	0x00, // 93 (unassigned)
	0x00, // 94 (unassigned)
	0x00, // 95 (unassigned)
	0x00, // 96 (unassigned)
	0x00, // 97 (unassigned)
	0x00, // 98 (unassigned)
	0x00, // 99 (unassigned)
	0x00, // 9A (unassigned)
	0x00, // 9B (unassigned)
	0x00, // 9C (unassigned)
	0x00, // 9D (unassigned)
	0x00, // 9E (unassigned)
	0x00, // 9F (unassigned)
	0x00, // A0 (unassigned)
	0x00, // A1 (unassigned)
	0x00, // A2 (unassigned)
	0x00, // A3 (unassigned)
	0x00, // A4 (unassigned)
	0x00, // A5 (unassigned)
	0x00, // A6 (unassigned)
	0x00, // A7 (unassigned)
	0x00, // A8 (unassigned)
	0x00, // A9 (unassigned)
	0x00, // AA (unassigned)
	0x00, // AB (unassigned)
	0x00, // AC (unassigned)
	0x00, // AD (unassigned)
	0x00, // AE (unassigned)
	0x00, // AF (unassigned)
	0x00, // B0 (unassigned)
	0x00, // B1 (unassigned)
	0x00, // B2 (unassigned)
	0x00, // B3 (unassigned)
	0x00, // B4 (unassigned)
	0x00, // B5 (unassigned)
	0x00, // B6 (unassigned)
	0x00, // B7 (unassigned)
	0x00, // B8 (unassigned)
	0x00, // B9 (unassigned)
	0x00, // BA (unassigned)
	0x00, // BB (unassigned)
	0x00, // BC (unassigned)
	0x00, // BD (unassigned)
	0x00, // BE (unassigned)
	0x00, // BF (unassigned)
	0x00, // C0 (unassigned)
	0x00, // C1 (unassigned)
	0x00, // C2 (unassigned)
	0x00, // C3 (unassigned)
	0x00, // C4 (unassigned)
	0x00, // C5 (unassigned)
	0x00, // C6 (unassigned)
	0x00, // C7 (unassigned)
	0x00, // C8 (unassigned)
	0x00, // C9 (unassigned)
	0x00, // CA (unassigned)
	0x00, // CB (unassigned)
	0x00, // CC (unassigned)
	0x00, // CD (unassigned)
	0x00, // CE (unassigned)
	0x00, // CF (unassigned)
	0x00, // D0 (unassigned)
	0x00, // D1 (unassigned)
	0x00, // D2 (unassigned)
	0x00, // D3 (unassigned)
	0x00, // D4 (unassigned)
	0x00, // D5 (unassigned)
	0x00, // D6 (unassigned)
	0x00, // D7 (unassigned)
	0x00, // D8 (unassigned)
	0x00, // D9 (unassigned)
	0x00, // DA (unassigned)
	0x00, // DB (unassigned)
	0x00, // DC (unassigned)
	0x00, // DD (unassigned)
	0x00, // DE (unassigned)
	0x00, // DF (unassigned)
	0x00, // E0 (unassigned)
	0x48, // E1 14 77 E1 F0 14 F0 77 (Pause)
	0x00, // E2 (unassigned)
	0x00, // E3 (unassigned)
	0x00, // E4 (unassigned)
	0x00, // E5 (unassigned)
	0x00, // E6 (unassigned)
	0x00, // E7 (unassigned)
	0x00, // E8 (unassigned)
	0x00, // E9 (unassigned)
	0x00, // EA (unassigned)
	0x00, // EB (unassigned)
	0x00, // EC (unassigned)
	0x00, // ED (unassigned)
	0x00, // EE (unassigned)
	0x00, // EF (unassigned)
	0x00, // F0 (unassigned)
	0x91, // F1 (Keyboard Lang 2 ?? (Hanja))
	0x90, // F2 (Keyboard Lang 1 ?/? (Hanguel/English))
	0x00, // F3 (unassigned)
	0x00, // F4 (unassigned)
	0x00, // F5 (unassigned)
	0x00, // F6 (unassigned)
	0x00, // F7 (unassigned)
	0x00, // F8 (unassigned)
	0x00, // F9 (unassigned)
	0x00, // FA (unassigned)
	0x00, // FB (unassigned)
	0x02 // FC (POST Fail)
};

PROGMEM uint8_t sc_hid_extended[] =
{
	0x00, // 00 (unassigned)
	0x00, // 01 (unassigned)
	0x00, // 02 (unassigned)
	0x00, // 03 (unassigned)
	0x00, // 04 (unassigned)
	0x00, // 05 (unassigned)
	0x00, // 06 (unassigned)
	0x00, // 07 (unassigned)
	0x00, // 08 (unassigned)
	0x00, // 09 (unassigned)
	0x00, // 0A (unassigned)
	0x00, // 0B (unassigned)
	0x00, // 0C (unassigned)
	0x00, // 0D (unassigned)
	0x00, // 0E (unassigned)
	0x00, // 0F (unassigned)
	0x00, // 10 (unassigned)
	0xE6, // E0 11 (Right Alt)
	0x00, // 12 (unassigned)
	0x00, // 13 (unassigned)
	0xE4, // E0 14 (Right Control)
	0x00, // 15 (unassigned)
	0x00, // 16 (unassigned)
	0x00, // 17 (unassigned)
	0x00, // 18 (unassigned)
	0x00, // 19 (unassigned)
	0x00, // 1A (unassigned)
	0x00, // 1B (unassigned)
	0x00, // 1C (unassigned)
	0x00, // 1D (unassigned)
	0x00, // 1E (unassigned)
	0xE3, // E0 1F (Left GUI)
	0x00, // 20 (unassigned)
	0x00, // 21 (unassigned)
	0x00, // 22 (unassigned)
	0x00, // 23 (unassigned)
	0x00, // 24 (unassigned)
	0x00, // 25 (unassigned)
	0x00, // 26 (unassigned)
	0xE7, // E0 27 (Right GUI)
	0x00, // 28 (unassigned)
	0x00, // 29 (unassigned)
	0x00, // 2A (unassigned)
	0x00, // 2B (unassigned)
	0x00, // 2C (unassigned)
	0x00, // 2D (unassigned)
	0x00, // 2E (unassigned)
	0x65, // E0 2F (App)
	0x00, // 30 (unassigned)
	0x00, // 31 (unassigned)
	0x00, // 32 (unassigned)
	0x00, // 33 (unassigned)
	0x00, // 34 (unassigned)
	0x00, // 35 (unassigned)
	0x00, // 36 (unassigned)
	0x66, // E0 37 (Keyboard Power)
	0x00, // 38 (unassigned)
	0x00, // 39 (unassigned)
	0x00, // 3A (unassigned)
	0x00, // 3B (unassigned)
	0x00, // 3C (unassigned)
	0x00, // 3D (unassigned)
	0x00, // 3E (unassigned)
	0x00, // 3F (unassigned)
	0x00, // 40 (unassigned)
	0x00, // 41 (unassigned)
	0x00, // 42 (unassigned)
	0x00, // 43 (unassigned)
	0x00, // 44 (unassigned)
	0x00, // 45 (unassigned)
	0x00, // 46 (unassigned)
	0x00, // 47 (unassigned)
	0x00, // 48 (unassigned)
	0x00, // 49 (unassigned)
	0x54, // E0 4A (Keypad / (Note 1))
	0x00, // 4B (unassigned)
	0x00, // 4C (unassigned)
	0x00, // 4D (unassigned)
	0x00, // 4E (unassigned)
	0x00, // 4F (unassigned)
	0x00, // 50 (unassigned)
	0x00, // 51 (unassigned)
	0x00, // 52 (unassigned)
	0x00, // 53 (unassigned)
	0x00, // 54 (unassigned)
	0x00, // 55 (unassigned)
	0x00, // 56 (unassigned)
	0x00, // 57 (unassigned)
	0x00, // 58 (unassigned)
	0x00, // 59 (unassigned)
	0x58, // E0 5A (Keypad Enter)
	0x00, // 5B (unassigned)
	0x00, // 5C (unassigned)
	0x00, // 5D (unassigned)
	0x00, // 5E (unassigned)
	0x00, // 5F (unassigned)
	0x00, // 60 (unassigned)
	0x00, // 61 (unassigned)
	0x00, // 62 (unassigned)
	0x00, // 63 (unassigned)
	0x00, // 64 (unassigned)
	0x00, // 65 (unassigned)
	0x00, // 66 (unassigned)
	0x00, // 67 (unassigned)
	0x00, // 68 (unassigned)
	0x4D, // E0 69 (End (Note 1))
	0x00, // 6A (unassigned)
	0x50, // E0 6B (Left Arrow (Note 1))
	0x4A, // E0 6C (Home (Note 1))
	0x00, // 6D (unassigned)
	0x00, // 6E (unassigned)
	0x00, // 6F (unassigned)
	0x49, // E0 70 (Insert (Note 1))
	0x4C, // E0 71 (Delete (Note 1))
	0x51, // E0 72 (Down Arrow (Note 1))
	0x00, // 73 (unassigned)
	0x4F, // E0 74 (Right Arrow (Note 1))
	0x52, // E0 75 (Up Arrow (Note 1))
	0x00, // 76 (unassigned)
	0x00, // 77 (unassigned)
	0x00, // 78 (unassigned)
	0x00, // 79 (unassigned)
	0x4E, // E0 7A (Page Down (Note 1))
	0x00, // 7B (unassigned)
	0x46, // E0 7C (Print Screen (Note 1))
	0x4B, // E0 7D (Page Up (Note 1))
	0x48 // E0 7E E0 F0 7E (Break (Ctrl-Pause))
};

#endif /* TTABLE_H_ */
